#
# TracPage
#  A page importing product
#
# TracPage.py
#  The Product
#
# Author: Nigel Sim <nigel.sim@jcu.edu.au>
#
# Released under GNU GPL v2 or later
#

from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
from Products.validation import V_REQUIRED
from AccessControl import ClassSecurityInfo
from Products.CMFCore.utils import getToolByName
from Products.PloneTrac.config import PROJECTNAME

from zope.interface import implements
from Products.PloneTrac.interfaces import ITracPage

import xmlrpclib
import logging
logger = logging.getLogger("TracPage")

class TracPage(BaseContent):
    """ Show my tickets container """
    meta_type = 'TracPage'
    
    security  = ClassSecurityInfo()
    _at_rename_after_creation = True

    implements(ITracPage)
    ##
    ##  The Schema includes two variables, on for the Repository itself and one for a Path within the Repository
    ##
    schema = BaseSchema + Schema((
        StringField('url',required=True, widget=StringWidget(description="Sites to search")),
        TextField('text',required=False, searchable=True, 
		widget=RichWidget(description="",visible=0)),
        ))
    
    ## Set the icon for the ShoeBox
    #content_icon = 'shoebox.png'
    
    ##
    ##  Redefine the view tab (action) for ShoeBox
    ##
    actions = (
            {
                    'id': 'view',
                    'name': 'View',
                    'action': 'string:${object_url}/trac_page_view',
                    'permissions': (CMFCorePermissions.View,),
                    'category':'object',
            },
    )

## Register the new type within Zope
registerType(TracPage,PROJECTNAME)
