#
# TracSearch
#  A start product for Plone - TracSearch
#
# TracTicketView.py
#  The Product
#
# Author: Nigel Sim <nigel.sim@jcu.edu.au>
#
# Released under GNU GPL v2 or later
#

from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
from Products.validation import V_REQUIRED
from AccessControl import ClassSecurityInfo
from Products.CMFCore.utils import getToolByName
from Products.PloneTrac.config import PROJECTNAME

import xmlrpclib

class TracSearch(BaseContent):
    """ Show my tickets container """
    meta_type = 'TracSearch'
    
    security  = ClassSecurityInfo()
    _at_rename_after_creation = True

    ##
    ##  The Schema includes two variables, on for the Repository itself and one for a Path within the Repository
    ##
    schema = BaseSchema + Schema((
        LinesField('urls',required=True, widget=LinesWidget(description="Sites to search")),
        #StringField('query',required=True, widget=StringWidget(description="Query to run. %u = current user")),
        ))
    
    ## Set the icon for the ShoeBox
    #content_icon = 'shoebox.png'
    
    ##
    ##  Redefine the view tab (action) for ShoeBox
    ##
    actions = (
            {
                    'id': 'view',
                    'name': 'View',
                    'action': 'string:${object_url}/trac_search_view',
                    'permissions': (CMFCorePermissions.View,),
                    'category':'object',
            },
    )

    def getResults(self, query):
        """
	Run the query on all the listed urls, logging any errors
	"""
        res = []
	failed = []
	q = query['q']
	filter = []
	if (query.has_key('wiki')):
		filter.append('wiki')
	if (query.has_key('changeset')):
		filter.append('changeset')
	if (query.has_key('ticket')):
		filter.append('ticket')
        for url in self.urls:
	    try:
                s = xmlrpclib.ServerProxy(url+"/xmlrpc")
                res += s.search.performSearch(q, filter)
	    except:
	        failed.append(url)
        return res, failed

    def getCookedQuery(self):
        q = self.query
        mtool = getToolByName(self, 'portal_membership')
	userName = mtool.getAuthenticatedMember().getId()
	if userName != None:
            q = q.replace('%u', userName)
	return q
## Register the new type within Zope
registerType(TracSearch,PROJECTNAME)
