#
# TracTicketView
#  A start product for Plone - TracTicketView
#
# TracTicketView.py
#  The Product
#
# Author: Nigel Sim <nigel.sim@jcu.edu.au>
#
# Released under GNU GPL v2 or later
#

from Products.Archetypes.public import *
from Products.CMFCore import CMFCorePermissions
from Products.validation import V_REQUIRED
from AccessControl import ClassSecurityInfo
from Products.CMFCore.utils import getToolByName
from Products.PloneTrac.config import PROJECTNAME

import xmlrpclib

class TracTicketView(BaseContent):
    """ Show my tickets container """
    meta_type = 'TracTicketView'
    
    security  = ClassSecurityInfo()
    _at_rename_after_creation = True

    ##
    ##  The Schema includes two variables, on for the Repository itself and one for a Path within the Repository
    ##
    schema = BaseSchema + Schema((
        LinesField('urls',required=True, widget=LinesWidget(description="Sites to search")),
        StringField('query',required=True, widget=StringWidget(description="Query to run. %u = current user")),
        ))
    
    ## Set the icon for the ShoeBox
    #content_icon = 'shoebox.png'
    
    ##
    ##  Redefine the view tab (action) for ShoeBox
    ##
    actions = (
            {
                    'id': 'view',
                    'name': 'View',
                    'action': 'string:${object_url}/trac_ticket_view',
                    'permissions': (CMFCorePermissions.View,),
                    'category':'object',
            },
    )

    def getTickets(self):
        """
	Run the query on all the listed urls, returning a dictionary of urls, with
	tickets attached.
	"""
        res = {}
	failed = []
	query = self.getCookedQuery()
        for url in self.urls:
	    try:
                s = xmlrpclib.ServerProxy(url+"/xmlrpc")
                multicall = xmlrpclib.MultiCall(s)
                for t in s.ticket.query(query):
	            multicall.ticket.get(t)
                res[url] = multicall()
	    except:
	        failed.append(url)
        return res, failed

    def getCookedQuery(self):
        q = self.query
        mtool = getToolByName(self, 'portal_membership')
	userName = mtool.getAuthenticatedMember().getId()
	if userName != None:
            q = q.replace('%u', userName)
	return q
## Register the new type within Zope
registerType(TracTicketView,PROJECTNAME)
